org.scalatest

# StackDepthException

#### class StackDepthException extends RuntimeException with StackDepth

Exception class that encapsulates information about the stack depth at which the line of code that failed resides, so that information can be presented to the user that makes it quick to find the failing line of code. (In other words, the user need not scan through the stack trace to find the correct filename and line number of the problem code.) Having a stack depth is more useful in a testing environment in which test failures are implemented as thrown exceptions, as is the case in ScalaTest's built-in suite traits.

Attributes
  abstract

Linear Supertypes
StackDepth, RuntimeException, Exception, Throwable, Serializable, AnyRef, Any
Known Subclasses
DuplicateTestNameException, GeneratorDrivenPropertyCheckFailedException, NotAllowedException, PropertyCheckFailedException, PropertyTestFailedException, TableDrivenPropertyCheckFailedException, TestFailedException, TestRegistrationClosedException
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. StackDepthException
2. StackDepth
3. RuntimeException
4. Exception
5. Throwable
6. Serializable
7. AnyRef
8. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new StackDepthException (message: Option[String], cause: Option[Throwable], failedCodeStackDepth: Int)

   Constructs a `StackDepthException` with an optional pre-determined `message`, optional `cause`, and and `failedCodeStackDepth`.

   Constructs a `StackDepthException` with an optional pre-determined `message`, optional `cause`, and and `failedCodeStackDepth`. (This was the primary constructor form prior to ScalaTest 1.5.)

   message

     an optional detail message for this `StackDepthException`.

   cause

     an optional cause, the `Throwable` that caused this `StackDepthException` to be thrown.

   failedCodeStackDepth

     the depth in the stack trace of this exception at which the line of test code that failed resides.

2. #### new StackDepthException (message: Option[String], cause: Option[Throwable], failedCodeStackDepthFun: (StackDepthException) ⇒ Int)

   Constructs a `StackDepthException` with an optional pre-determined `message`, optional cause, and a `failedCodeStackDepth` function.

   Constructs a `StackDepthException` with an optional pre-determined `message`, optional cause, and a `failedCodeStackDepth` function.

   message

     an optional detail message for this `StackDepthException`.

   cause

     an optional cause, the `Throwable` that caused this `StackDepthException` to be thrown.

3. #### new StackDepthException (messageFun: (StackDepthException) ⇒ Option[String], cause: Option[Throwable], failedCodeStackDepthFun: (StackDepthException) ⇒ Int)

   messageFun

     an function that produces an optional detail message for this `StackDepthException`.

   cause

     an optional cause, the `Throwable` that caused this `StackDepthException` to be thrown.

   failedCodeStackDepthFun

     a function that produces the depth in the stack trace of this exception at which the line of test code that failed resides.

### Abstract Value Members

1. #### def severedAtStackDepth : Throwable with StackDepth

   Returns an exception of the same class with `failedExceptionStackDepth` set to 0 and all frames above this stack depth severed off.

   Returns an exception of the same class with `failedExceptionStackDepth` set to 0 and all frames above this stack depth severed off. This can be useful when working with tools (such as IDEs) that do not directly support ScalaTest. (Tools that directly support ScalaTest can use the stack depth information delivered in the StackDepth exceptions.)

   Attributes
     abstract
   Definition Classes
     StackDepth

### Concrete Value Members

1. #### def != (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

2. #### def != (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

3. #### def ## (): Int

   Attributes
     final
   Definition Classes
     AnyRef → Any

4. #### def == (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

5. #### def == (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

6. #### def asInstanceOf [T0] : T0

   Attributes
     final
   Definition Classes
     Any

7. #### def canEqual (other: Any): Boolean

   Indicates whether this object can be equal to the passed object.

8. #### val cause : Option[Throwable]

   an optional cause, the `Throwable` that caused this `StackDepthException` to be thrown.

   an optional cause, the `Throwable` that caused this `StackDepthException` to be thrown.

   Definition Classes
     StackDepthException → StackDepth

9. #### def clone (): AnyRef

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()

10. #### def eq (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

11. #### def equals (other: Any): Boolean

    Indicates whether this object is equal to the passed object.

    Indicates whether this object is equal to the passed object. If the passed object is a `StackDepthException`, equality requires equal `message`, `cause`, and `failedCodeStackDepth` fields, as well as equal return values of `getStackTrace`.

    Definition Classes
      StackDepthException → AnyRef → Any

12. #### def failedCodeFileName : Option[String]

    A string that provides the filename of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    A string that provides the filename of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    This is a `def` instead of a `val` because exceptions are mutable: their stack trace can be changed after the exception is created. This is done, for example, by the `SeveredStackTraces` trait.

    returns

      a string containing the filename that caused the failed test

    Definition Classes
      StackDepth

13. #### def failedCodeFileNameAndLineNumberString : Option[String]

    A string that provides the filename and line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    A string that provides the filename and line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    This is a `def` instead of a `val` because exceptions are mutable: their stack trace can be changed after the exception is created. This is done, for example, by the `SeveredStackTraces` trait.

    returns

      a user-presentable string containing the filename and line number that caused the failed test

    Definition Classes
      StackDepth

14. #### def failedCodeLineNumber : Option[Int]

    A string that provides the line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    A string that provides the line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    This is a `def` instead of a `val` because exceptions are mutable: their stack trace can be changed after the exception is created. This is done, for example, by the `SeveredStackTraces` trait.

    returns

      a string containing the line number that caused the failed test

    Definition Classes
      StackDepth

15. #### lazy val failedCodeStackDepth : Int

    The depth in the stack trace of this exception at which the line of test code that failed resides.

    The depth in the stack trace of this exception at which the line of test code that failed resides.

    One reason this is lazy is to delay any searching of the stack trace until it is actually needed. It will usually be needed, but not always. For example, exceptions thrown during a shrink phase of a failed property will often be `StackDepthException`s, but whose `failedCodeStackDepth` will never be used. Another reason is to remove the need to create a different exception before creating this one just for the purpose of searching through its stack trace for the proper stack depth. Still one more reason is to allow the message to contain information about the stack depth, such as the failed file name and line number.

    Definition Classes
      StackDepthException → StackDepth

16. #### val failedCodeStackDepthFun : (StackDepthException) ⇒ Int

    a function that produces the depth in the stack trace of this exception at which the line of test code that failed resides.

17. #### def fillInStackTrace (): Throwable

    Definition Classes
      Throwable

18. #### def finalize (): Unit

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()

19. #### def getCause (): Throwable

    Definition Classes
      Throwable

20. #### def getClass (): java.lang.Class[_]

    Attributes
      final
    Definition Classes
      AnyRef

21. #### def getLocalizedMessage (): String

    Definition Classes
      Throwable

22. #### def getMessage (): String

    Returns the detail message string of this `StackDepthException`.

    Returns the detail message string of this `StackDepthException`.

    returns

      the detail message string of this `StackDepthException` instance (which may be `null`).

    Definition Classes
      StackDepthException → Throwable

23. #### def getStackTrace (): Array[StackTraceElement]

    Definition Classes
      Throwable

24. #### def hashCode (): Int

    Returns a hash code value for this object.

    Returns a hash code value for this object.

    Definition Classes
      StackDepthException → AnyRef → Any

25. #### def initCause (throwable: Throwable): Throwable

    Attributes
      final
    Definition Classes
      StackDepthException → Throwable

26. #### def isInstanceOf [T0] : Boolean

    Attributes
      final
    Definition Classes
      Any

27. #### lazy val message : Option[String]

    An optional detail message for this `StackDepth` exception.

    An optional detail message for this `StackDepth` exception.

    One reason this is lazy is to delay any searching of the stack trace until it is actually needed. It will usually be needed, but not always. For example, exceptions thrown during a shrink phase of a failed property will often be `StackDepthException`s, but whose `message` will never be used. Another related reason is to remove the need to create a different exception before creating this one just for the purpose of searching through its stack trace for the proper stack depth. Still one more reason is to allow the message to contain information about the stack depth, such as the failed file name and line number.

    Definition Classes
      StackDepthException → StackDepth

28. #### val messageFun : (StackDepthException) ⇒ Option[String]

    an function that produces an optional detail message for this `StackDepthException`.

29. #### def ne (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

30. #### def notify (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

31. #### def notifyAll (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

32. #### def printStackTrace (arg0: PrintWriter): Unit

    Definition Classes
      Throwable

33. #### def printStackTrace (arg0: PrintStream): Unit

    Definition Classes
      Throwable

34. #### def printStackTrace (): Unit

    Definition Classes
      Throwable

35. #### def setStackTrace (arg0: Array[StackTraceElement]): Unit

    Definition Classes
      Throwable

36. #### def synchronized [T0] (arg0: ⇒ T0): T0

    Attributes
      final
    Definition Classes
      AnyRef

37. #### def toString (): String

    Definition Classes
      Throwable → AnyRef → Any

38. #### def wait (): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

39. #### def wait (arg0: Long, arg1: Int): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

40. #### def wait (arg0: Long): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from StackDepth

### Inherited from RuntimeException

### Inherited from Exception

### Inherited from Throwable

### Inherited from Serializable

### Inherited from AnyRef

### Inherited from Any